;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-advanced-reader.ss" "lang")((modname cc2-gr2) (read-case-sensitive #t) (teachpacks ((lib "valrose.rkt" "installed-teachpacks"))) (htdp-settings #(#t write mixed-fraction #t #t none #f ((lib "valrose.rkt" "installed-teachpacks")) #f)))
;;;
;;; cc2-gr2.rkt
;;; Fac Sciences Nice, L1-Info, Printemps 2017
(require net/sendurl)

;;; Question 1a

(define (drop L n)    ; On suppose n >= length(L)
  (if (= n 0)         ; ne PAS utiliser length qui aboutit a une complexite quadratique...
      L
      (drop (rest L) (- n 1))))

(check-expect (drop '(a b c d e) 3) '(d e))

;;; Question 1b
;;; Elle est iterative, l'appel recursif étant en position terminale.
(send-url "https://fr.wikipedia.org/wiki/R%e9cursion_terminale")

;;; Question 2a

(define (polygone n c)
  (if (= n 0)
      empty
      (cons (make-posn (random c) (random c)) (polygone (- n 1) c))))

(show (polygone 5 300))

;;; La fonction polygone ci-dessus n'est PAS iterative car l'appel récursif est "enveloppe"
;;; par la fonction cons.

;;; Question 2b
;;; Reprogrammez la fonction (polygone n c) de maniere ITERATIVE.

(define (polygone_it n c)
  (local [(define (iter n acc)
            (if (= n 0)
                acc       ; inutile d'inverser, tout est aleatoire !
                (iter (- n 1) (cons (make-posn (random c) (random c)) acc))))]
    (iter n empty)))

(show (polygone_it 5 300))

;;; Question 2c

(define (polygone_os n c)
  (build-list n (lambda (i) (make-posn (random c) (random c)))))

(show (polygone_it 5 300))

;;; Question 3, style au choix

(define (rmap f pred? L)   ; en style recursif enveloppe
  (if (empty? L)
      L
      (local [(define x (f (first L)))]     ; ne pas calculer deux fois (f (first L))...
        (if (pred? x)
            (cons x (rmap f pred? (rest L)))
            (rmap f pred? (rest L))))))

(check-expect (rmap sqr (lambda (x) (> x 20)) '(3 -6 5 1 10 2))
              '(36 25 100))

(define (rmap_it f pred? L)   ; en style iteratif
  (local [(define (iter L acc)
            (if (empty? L)
                (reverse acc)
                (local [(define x (f (first L)))]
                  (iter (rest L)
                        (if (pred? x) (cons x acc) acc)))))]
    (iter L empty)))

(check-expect (rmap_it sqr (lambda (x) (> x 20)) '(3 -6 5 1 10 2))
              '(36 25 100))

(define (rmap_os f pred? L)   ; en style ordre superieur
  (filter pred? (map f L)))

(check-expect (rmap_os sqr (lambda (x) (> x 20)) '(3 -6 5 1 10 2))
              '(36 25 100))

;;; Question 4

(define (anim-cc2-gr2)
  (local [(define FOND (rectangle 200 200 'solid "lightblue"))
          (define-struct goutte (x y r))
          ; le monde est une liste L de gouttes
          (define INIT empty)       ; au début il ne pleut pas !
          (define (suivant L)
            (if (empty? L)          ; deux gouttes naissent a chaque top d'horloge
                (build-list 2 (lambda (i) (make-goutte (random 200) (random 200) 0)))   
                (local [(match-define (goutte x y r) (first L))]
                  (if (>= r 4)
                      (suivant (rest L))
                      (cons (make-goutte x y (+ r 1)) (suivant (rest L)))))))
          (define (dessiner L)
            (if (empty? L)
                FOND
                (local [(match-define (goutte x y r) (first L))]
                  (place-image (circle r 'outline "blue") x y (dessiner (rest L))))))
          (define (dessiner_ L)    ; la meme avec reduce
            (reduce (lambda (b hr)
                      (place-image (circle (goutte-r b) 'outline "blue") (goutte-x b) (goutte-y b) hr))
                    FOND L))
          (define START (current-milliseconds))              ; START CHRONO !
          (define (final? L)
            (> (current-milliseconds) (+ START 15000)))]     ; 15 sec from START
     (big-bang INIT
              (on-tick suivant)
              (on-draw dessiner)
              (stop-when final?)))) 

(void (anim-cc2-gr2))




























